# iosxr_command – Run commands on remote devices running Cisco IOS XR

- Synopsis
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Sends arbitrary commands to an IOS XR node and returns the results read from the device. This module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.
- This module does not support running commands in configuration mode. Please use iosxr_config to configure iosxr devices.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
commands - / required |  | List of commands to send to the remote iosxr device over the configured provider. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retries has expired.
interval - | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again.

match
-

Choices:
- any
- all ←

The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.

provider
dictionary

Deprecated
Starting with Ansible 2.5 we recommend using `connection: network_cli`.
For more information please see the Network Guide.

A dict object containing connection details.

| host string / required |  | Specifies the DNS host name or address for connecting to the remote device over the specified transport. The value of host is used as the destination address for the transport.
| password string |  | Specifies the password to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_PASSWORD` will be used instead.
| port integer | Default: 22 | Specifies the port to use when building the connection to the remote device.
| ssh_keyfile path |  | Specifies the SSH key to use to authenticate the connection to the remote device. This value is the path to the key used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_SSH_KEYFILE` will be used instead.
| timeout integer | Default: 10 | Specifies the timeout in seconds for communicating with the network device for either connecting or sending commands. If the timeout is exceeded before the operation is completed, the module will error.
| username string |  | Configures the username to use to authenticate the connection to the remote device. This value is used to authenticate the SSH session. If the value is not specified in the task, the value of environment variable `ANSIBLE_NET_USERNAME` will be used instead.
retries - | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions.
wait_for - |  | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples. aliases: waitfor

## Notes

Note

- Make sure the user has been authorized to execute commands terminal length 0, terminal width 512 and terminal exec prompt no-timestamp.
- This module works with `network_cli`. See the IOS-XR Platform Options.
- This module does not support `netconf` connection.
- Tested against IOS XR 6.1.3
- For more information on using Ansible to manage network devices see the Ansible Network Guide
- For more information on using Ansible to manage Cisco devices see the Cisco integration page.

## Examples

    tasks:
      - name: run show version on remote devices
        iosxr_command:
          commands: show version

      - name: run show version and check to see if output contains iosxr
        iosxr_command:
          commands: show version
          wait_for: result[0] contains IOS-XR

      - name: run multiple commands on remote nodes
        iosxr_command:
          commands:
            - show version
            - show interfaces
            - { command: example command that prompts, prompt: expected prompt, answer: yes}

      - name: run multiple commands and evaluate the output
        iosxr_command:
          commands:
            - show version
            - show interfaces
          wait_for:
            - result[0] contains IOS-XR
            - result[1] contains Loopback0

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | The list of conditionals that have failed Sample: ['...', '...']
stdout list | always apart from low level errors (such as action plugin) | The set of responses from the commands Sample: ['...', '...']
stdout_lines list | always apart from low level errors (such as action plugin) | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Network Team. [network]

### Red Hat Support

More information about Red Hat’s support of this module is available from this Red Hat Knowledge Base article.

### Authors

- Ricardo Carrillo Cruz (@rcarrillocruz)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.